// "./cfa min.c"
// "./cfa -CFA min.c > min_out.c"
// "gcc32 -g min_out.c LibCfa/libcfa.a"

extern "C" {
    int printf( const char *, ... );
}

forall( type T | { const T 0; int ?!=?(T, T); int ?<?(T, T); } )
T min( T t1, T t2 ) {
    return t1 < t2 ? t1 : t2;
}

int main() {
    float f;
    f = min( 4.0, 3.0 );
    printf( "result is %f\n", f );
}
